/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.emftext.language.java.annotations.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import org.emftext.language.java.annotations.util.AnnotationsAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class AnnotationsItemProviderAdapterFactory extends AnnotationsAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable
{
  /**
   * This keeps track of the root adapter factory that delegates to this adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ComposedAdapterFactory parentAdapterFactory;

  /**
   * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IChangeNotifier changeNotifier = new ChangeNotifier();

  /**
   * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected Collection<Object> supportedTypes = new ArrayList<Object>();

  /**
   * This constructs an instance.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AnnotationsItemProviderAdapterFactory()
  {
    supportedTypes.add(IEditingDomainItemProvider.class);
    supportedTypes.add(IStructuredItemContentProvider.class);
    supportedTypes.add(ITreeItemContentProvider.class);
    supportedTypes.add(IItemLabelProvider.class);
    supportedTypes.add(IItemPropertySource.class);
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.annotations.AnnotationInstance} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AnnotationInstanceItemProvider annotationInstanceItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.annotations.AnnotationInstance}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createAnnotationInstanceAdapter()
  {
    if (annotationInstanceItemProvider == null)
    {
      annotationInstanceItemProvider = new AnnotationInstanceItemProvider(this);
    }

    return annotationInstanceItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.annotations.SingleAnnotationParameter} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SingleAnnotationParameterItemProvider singleAnnotationParameterItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.annotations.SingleAnnotationParameter}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createSingleAnnotationParameterAdapter()
  {
    if (singleAnnotationParameterItemProvider == null)
    {
      singleAnnotationParameterItemProvider = new SingleAnnotationParameterItemProvider(this);
    }

    return singleAnnotationParameterItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.annotations.AnnotationParameterList} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AnnotationParameterListItemProvider annotationParameterListItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.annotations.AnnotationParameterList}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createAnnotationParameterListAdapter()
  {
    if (annotationParameterListItemProvider == null)
    {
      annotationParameterListItemProvider = new AnnotationParameterListItemProvider(this);
    }

    return annotationParameterListItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.annotations.AnnotationAttributeSetting} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AnnotationAttributeSettingItemProvider annotationAttributeSettingItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.annotations.AnnotationAttributeSetting}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createAnnotationAttributeSettingAdapter()
  {
    if (annotationAttributeSettingItemProvider == null)
    {
      annotationAttributeSettingItemProvider = new AnnotationAttributeSettingItemProvider(this);
    }

    return annotationAttributeSettingItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.annotations.AnnotationAttribute} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AnnotationAttributeItemProvider annotationAttributeItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.annotations.AnnotationAttribute}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createAnnotationAttributeAdapter()
  {
    if (annotationAttributeItemProvider == null)
    {
      annotationAttributeItemProvider = new AnnotationAttributeItemProvider(this);
    }

    return annotationAttributeItemProvider;
  }

  /**
   * This returns the root adapter factory that contains this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComposeableAdapterFactory getRootAdapterFactory()
  {
    return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
  }

  /**
   * This sets the composed adapter factory that contains this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
  {
    this.parentAdapterFactory = parentAdapterFactory;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object type)
  {
    return supportedTypes.contains(type) || super.isFactoryForType(type);
  }

  /**
   * This implementation substitutes the factory itself as the key for the adapter.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter adapt(Notifier notifier, Object type)
  {
    return super.adapt(notifier, this);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object adapt(Object object, Object type)
  {
    if (isFactoryForType(type))
    {
      Object adapter = super.adapt(object, type);
      if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter)))
      {
        return adapter;
      }
    }

    return null;
  }

  /**
   * This adds a listener.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void addListener(INotifyChangedListener notifyChangedListener)
  {
    changeNotifier.addListener(notifyChangedListener);
  }

  /**
   * This removes a listener.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void removeListener(INotifyChangedListener notifyChangedListener)
  {
    changeNotifier.removeListener(notifyChangedListener);
  }

  /**
   * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void fireNotifyChanged(Notification notification)
  {
    changeNotifier.fireNotifyChanged(notification);

    if (parentAdapterFactory != null)
    {
      parentAdapterFactory.fireNotifyChanged(notification);
    }
  }

  /**
   * This disposes all of the item providers created by this factory. 
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void dispose()
  {
    if (annotationInstanceItemProvider != null) annotationInstanceItemProvider.dispose();
    if (singleAnnotationParameterItemProvider != null) singleAnnotationParameterItemProvider.dispose();
    if (annotationParameterListItemProvider != null) annotationParameterListItemProvider.dispose();
    if (annotationAttributeSettingItemProvider != null) annotationAttributeSettingItemProvider.dispose();
    if (annotationAttributeItemProvider != null) annotationAttributeItemProvider.dispose();
  }

}
