/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.emftext.language.java.statements.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import org.emftext.language.java.statements.util.StatementsAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class StatementsItemProviderAdapterFactory extends StatementsAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable
{
  /**
   * This keeps track of the root adapter factory that delegates to this adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ComposedAdapterFactory parentAdapterFactory;

  /**
   * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IChangeNotifier changeNotifier = new ChangeNotifier();

  /**
   * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected Collection<Object> supportedTypes = new ArrayList<Object>();

  /**
   * This constructs an instance.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public StatementsItemProviderAdapterFactory()
  {
    supportedTypes.add(IEditingDomainItemProvider.class);
    supportedTypes.add(IStructuredItemContentProvider.class);
    supportedTypes.add(ITreeItemContentProvider.class);
    supportedTypes.add(IItemLabelProvider.class);
    supportedTypes.add(IItemPropertySource.class);
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.Assert} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AssertItemProvider assertItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.Assert}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createAssertAdapter()
  {
    if (assertItemProvider == null)
    {
      assertItemProvider = new AssertItemProvider(this);
    }

    return assertItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.Break} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected BreakItemProvider breakItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.Break}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createBreakAdapter()
  {
    if (breakItemProvider == null)
    {
      breakItemProvider = new BreakItemProvider(this);
    }

    return breakItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.Block} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected BlockItemProvider blockItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.Block}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createBlockAdapter()
  {
    if (blockItemProvider == null)
    {
      blockItemProvider = new BlockItemProvider(this);
    }

    return blockItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.CatchBlock} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CatchBlockItemProvider catchBlockItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.CatchBlock}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createCatchBlockAdapter()
  {
    if (catchBlockItemProvider == null)
    {
      catchBlockItemProvider = new CatchBlockItemProvider(this);
    }

    return catchBlockItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.Condition} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ConditionItemProvider conditionItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.Condition}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createConditionAdapter()
  {
    if (conditionItemProvider == null)
    {
      conditionItemProvider = new ConditionItemProvider(this);
    }

    return conditionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.Continue} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ContinueItemProvider continueItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.Continue}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createContinueAdapter()
  {
    if (continueItemProvider == null)
    {
      continueItemProvider = new ContinueItemProvider(this);
    }

    return continueItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.DefaultSwitchCase} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DefaultSwitchCaseItemProvider defaultSwitchCaseItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.DefaultSwitchCase}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createDefaultSwitchCaseAdapter()
  {
    if (defaultSwitchCaseItemProvider == null)
    {
      defaultSwitchCaseItemProvider = new DefaultSwitchCaseItemProvider(this);
    }

    return defaultSwitchCaseItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.DoWhileLoop} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DoWhileLoopItemProvider doWhileLoopItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.DoWhileLoop}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createDoWhileLoopAdapter()
  {
    if (doWhileLoopItemProvider == null)
    {
      doWhileLoopItemProvider = new DoWhileLoopItemProvider(this);
    }

    return doWhileLoopItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.EmptyStatement} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected EmptyStatementItemProvider emptyStatementItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.EmptyStatement}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createEmptyStatementAdapter()
  {
    if (emptyStatementItemProvider == null)
    {
      emptyStatementItemProvider = new EmptyStatementItemProvider(this);
    }

    return emptyStatementItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.ExpressionStatement} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ExpressionStatementItemProvider expressionStatementItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.ExpressionStatement}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createExpressionStatementAdapter()
  {
    if (expressionStatementItemProvider == null)
    {
      expressionStatementItemProvider = new ExpressionStatementItemProvider(this);
    }

    return expressionStatementItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.ForLoop} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ForLoopItemProvider forLoopItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.ForLoop}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createForLoopAdapter()
  {
    if (forLoopItemProvider == null)
    {
      forLoopItemProvider = new ForLoopItemProvider(this);
    }

    return forLoopItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.ForEachLoop} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ForEachLoopItemProvider forEachLoopItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.ForEachLoop}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createForEachLoopAdapter()
  {
    if (forEachLoopItemProvider == null)
    {
      forEachLoopItemProvider = new ForEachLoopItemProvider(this);
    }

    return forEachLoopItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.JumpLabel} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected JumpLabelItemProvider jumpLabelItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.JumpLabel}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createJumpLabelAdapter()
  {
    if (jumpLabelItemProvider == null)
    {
      jumpLabelItemProvider = new JumpLabelItemProvider(this);
    }

    return jumpLabelItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.LocalVariableStatement} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected LocalVariableStatementItemProvider localVariableStatementItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.LocalVariableStatement}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createLocalVariableStatementAdapter()
  {
    if (localVariableStatementItemProvider == null)
    {
      localVariableStatementItemProvider = new LocalVariableStatementItemProvider(this);
    }

    return localVariableStatementItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.NormalSwitchCase} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected NormalSwitchCaseItemProvider normalSwitchCaseItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.NormalSwitchCase}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createNormalSwitchCaseAdapter()
  {
    if (normalSwitchCaseItemProvider == null)
    {
      normalSwitchCaseItemProvider = new NormalSwitchCaseItemProvider(this);
    }

    return normalSwitchCaseItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.Return} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ReturnItemProvider returnItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.Return}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createReturnAdapter()
  {
    if (returnItemProvider == null)
    {
      returnItemProvider = new ReturnItemProvider(this);
    }

    return returnItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.Switch} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SwitchItemProvider switchItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.Switch}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createSwitchAdapter()
  {
    if (switchItemProvider == null)
    {
      switchItemProvider = new SwitchItemProvider(this);
    }

    return switchItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.SynchronizedBlock} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SynchronizedBlockItemProvider synchronizedBlockItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.SynchronizedBlock}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createSynchronizedBlockAdapter()
  {
    if (synchronizedBlockItemProvider == null)
    {
      synchronizedBlockItemProvider = new SynchronizedBlockItemProvider(this);
    }

    return synchronizedBlockItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.Throw} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ThrowItemProvider throwItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.Throw}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createThrowAdapter()
  {
    if (throwItemProvider == null)
    {
      throwItemProvider = new ThrowItemProvider(this);
    }

    return throwItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.TryBlock} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TryBlockItemProvider tryBlockItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.TryBlock}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createTryBlockAdapter()
  {
    if (tryBlockItemProvider == null)
    {
      tryBlockItemProvider = new TryBlockItemProvider(this);
    }

    return tryBlockItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.emftext.language.java.statements.WhileLoop} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected WhileLoopItemProvider whileLoopItemProvider;

  /**
   * This creates an adapter for a {@link org.emftext.language.java.statements.WhileLoop}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter createWhileLoopAdapter()
  {
    if (whileLoopItemProvider == null)
    {
      whileLoopItemProvider = new WhileLoopItemProvider(this);
    }

    return whileLoopItemProvider;
  }

  /**
   * This returns the root adapter factory that contains this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComposeableAdapterFactory getRootAdapterFactory()
  {
    return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
  }

  /**
   * This sets the composed adapter factory that contains this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
  {
    this.parentAdapterFactory = parentAdapterFactory;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object type)
  {
    return supportedTypes.contains(type) || super.isFactoryForType(type);
  }

  /**
   * This implementation substitutes the factory itself as the key for the adapter.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Adapter adapt(Notifier notifier, Object type)
  {
    return super.adapt(notifier, this);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object adapt(Object object, Object type)
  {
    if (isFactoryForType(type))
    {
      Object adapter = super.adapt(object, type);
      if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter)))
      {
        return adapter;
      }
    }

    return null;
  }

  /**
   * This adds a listener.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void addListener(INotifyChangedListener notifyChangedListener)
  {
    changeNotifier.addListener(notifyChangedListener);
  }

  /**
   * This removes a listener.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void removeListener(INotifyChangedListener notifyChangedListener)
  {
    changeNotifier.removeListener(notifyChangedListener);
  }

  /**
   * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void fireNotifyChanged(Notification notification)
  {
    changeNotifier.fireNotifyChanged(notification);

    if (parentAdapterFactory != null)
    {
      parentAdapterFactory.fireNotifyChanged(notification);
    }
  }

  /**
   * This disposes all of the item providers created by this factory. 
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void dispose()
  {
    if (assertItemProvider != null) assertItemProvider.dispose();
    if (breakItemProvider != null) breakItemProvider.dispose();
    if (blockItemProvider != null) blockItemProvider.dispose();
    if (catchBlockItemProvider != null) catchBlockItemProvider.dispose();
    if (conditionItemProvider != null) conditionItemProvider.dispose();
    if (continueItemProvider != null) continueItemProvider.dispose();
    if (defaultSwitchCaseItemProvider != null) defaultSwitchCaseItemProvider.dispose();
    if (doWhileLoopItemProvider != null) doWhileLoopItemProvider.dispose();
    if (emptyStatementItemProvider != null) emptyStatementItemProvider.dispose();
    if (expressionStatementItemProvider != null) expressionStatementItemProvider.dispose();
    if (forLoopItemProvider != null) forLoopItemProvider.dispose();
    if (forEachLoopItemProvider != null) forEachLoopItemProvider.dispose();
    if (jumpLabelItemProvider != null) jumpLabelItemProvider.dispose();
    if (localVariableStatementItemProvider != null) localVariableStatementItemProvider.dispose();
    if (normalSwitchCaseItemProvider != null) normalSwitchCaseItemProvider.dispose();
    if (returnItemProvider != null) returnItemProvider.dispose();
    if (switchItemProvider != null) switchItemProvider.dispose();
    if (synchronizedBlockItemProvider != null) synchronizedBlockItemProvider.dispose();
    if (throwItemProvider != null) throwItemProvider.dispose();
    if (tryBlockItemProvider != null) tryBlockItemProvider.dispose();
    if (whileLoopItemProvider != null) whileLoopItemProvider.dispose();
  }

}
